'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; }

var _Element2 = require('./Element');

var _Element3 = _interopRequireDefault(_Element2);

var _utilsLines = require('../utils/lines');

var Token = (function (_Element) {
    function Token(type, value) {
        _classCallCheck(this, Token);

        _get(Object.getPrototypeOf(Token.prototype), 'constructor', this).call(this, type, []);
        var isComment = false;
        var isWhitespace = false;
        var code = value;
        switch (type) {
            case 'Line':
                code = '//' + code;
                isComment = true;
                break;
            case 'Block':
                code = '/*' + code + '*/';
                isComment = true;
                break;
            case 'Whitespace':
                isWhitespace = true;
                break;
        }
        this._value = value;
        this._sourceCode = code;
        this._sourceCodeLength = code.length;
        this._isComment = isComment;
        this._isWhitespace = isWhitespace;
    }

    _inherits(Token, _Element);

    _createClass(Token, [{
        key: '_setChildren',
        value: function _setChildren(newChildren) {
            if (newChildren.length > 0) {
                throw new Error('Token nodes cannot contain child nodes');
            }

            this._childElements = newChildren;
        }
    }, {
        key: 'cloneElement',

        /**
         * Clones current Element structure.
         *
         * @returns {Element}
         */
        value: function cloneElement() {
            return new Token(this._type, this._value);
        }
    }, {
        key: 'firstToken',
        get: function () {
            return this;
        }
    }, {
        key: 'lastToken',
        get: function () {
            return this;
        }
    }, {
        key: 'isToken',
        get: function () {
            return true;
        }
    }, {
        key: 'isComment',
        get: function () {
            return this._isComment;
        }
    }, {
        key: 'isWhitespace',
        get: function () {
            return this._isWhitespace;
        }
    }, {
        key: 'value',
        get: function () {
            return this._value;
        }
    }, {
        key: 'sourceCode',
        get: function () {
            return this._sourceCode;
        }
    }, {
        key: 'sourceCodeLength',
        get: function () {
            return this._sourceCodeLength;
        }
    }, {
        key: 'lineBreakCount',
        get: function () {
            if (this._newLines === undefined) {
                this._newLines = (0, _utilsLines.countLineBreaks)(this._sourceCode);
            }
            return this._newLines;
        }
    }]);

    return Token;
})(_Element3['default']);

exports['default'] = Token;
module.exports = exports['default'];