/* jshint ignore:start */

'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

exports.isNewLine = isNewLine;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; }

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

var Literal = (function (_Expression) {
    function Literal(childNodes) {
        _classCallCheck(this, Literal);

        _get(Object.getPrototypeOf(Literal.prototype), 'constructor', this).call(this, 'Literal', childNodes);
    }

    _inherits(Literal, _Expression);

    _createClass(Literal, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            children.assertToken();
            var rawValue = children.currentElement.value;
            var value = undefined;
            switch (children.currentElement.type) {
                case 'Numeric':
                    value = parse(readNumberAuto, rawValue);
                    break;
                case 'Boolean':
                    value = parse(readBoolean, rawValue);
                    break;
                case 'Null':
                    value = parse(readNull, rawValue);
                    break;
                case 'String':
                    value = parse(readString, rawValue);
                    break;
                case 'RegularExpression':
                    value = parse(readRegexp, rawValue);
                    break;
                default:
                    throw new Error('Unvalid token type for Literal: ' + children.currentElement.type);
            }
            children.moveNext();
            children.assertEnd();

            this._value = value;
            this._raw = rawValue;
        }
    }, {
        key: 'value',
        get: function () {
            return this._value;
        }
    }, {
        key: 'raw',
        get: function () {
            return this._raw;
        }
    }]);

    return Literal;
})(_Expression3['default']);

exports['default'] = Literal;

function readBoolean(state) {
    state.pos = state.input.length;

    if (state.input === 'true') {
        return true;
    }

    if (state.input === 'false') {
        return false;
    }

    throw Error('Invalid boolean "' + state.input + '"');
}

function readNull(state) {
    state.pos = state.input.length;

    if (state.input === 'null') {
        return null;
    }

    throw Error('Invalid null "' + state.input + '"');
}

function parse(reader, input) {
    var state = { input: input, pos: 0 };
    var result = reader(state);

    if (state.pos !== input.length) {
        throw new Error('Invalid "' + reader.name + '" ' + state.pos + ', ' + input.length);
    }
    return result;
}

function readNumberAuto(state) {
    // TODO: Can be slow.
    if (state.input.charAt(state.pos) === '0' && state.input.charAt(state.pos + 1).match(/^(x|X|o|O|b|B)$/)) {
        var next = state.input.charCodeAt(state.pos + 1);
        if (next === 120 || next === 88) {
            return readRadixNumber(16, state);
        } // '0x', '0X' - hex number
        if (next === 111 || next === 79) {
            return readRadixNumber(8, state);
        } // '0o', '0O' - octal number
        if (next === 98 || next === 66) {
            return readRadixNumber(2, state);
        } // '0b', '0B' - binary number
        throw new Error('Invalid number: ' + state.input);
    } else {
        return readNumber(state);
    }
}

/*
 String parsing was adopted from Acorn: https://github.com/marijnh/acorn

 Copyright (C) 2012-2014 by various contributors (see AUTHORS)

 https://github.com/marijnh/acorn/blob/master/AUTHORS

 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
*/

function readString(state) {
    var quote = state.input.charCodeAt(0);
    var out = '';
    var chunkStart = ++state.pos;
    for (;;) {
        if (state.pos >= state.input.length) {
            throw new Error('Unterminated string constant');
        }
        var ch = state.input.charCodeAt(state.pos);
        if (ch === quote) {
            break;
        }
        if (ch === 92) {
            // '\'
            out += state.input.slice(chunkStart, state.pos);
            out += readEscapedChar(state);
            chunkStart = state.pos;
        } else {
            if (isNewLine(ch)) {
                throw new Error('Unterminated string constant');
            }
            state.pos++;
        }
    }
    out += state.input.slice(chunkStart, state.pos++);
    return out;
}

function readEscapedChar(state) {
    var ch = state.input.charCodeAt(++state.pos);
    var octal = /^[0-7]+/.exec(state.input.slice(state.pos, state.pos + 3));
    if (octal) {
        octal = octal[0];
    }
    while (octal && parseInt(octal, 8) > 255) {
        octal = octal.slice(0, -1);
    }
    if (octal === '0') {
        octal = null;
    }
    state.pos++;
    if (octal) {
        state.pos += octal.length - 1;
        return String.fromCharCode(parseInt(octal, 8));
    } else {
        switch (ch) {
            case 110:
                return '\n'; // 'n' -> '\n'
            case 114:
                return '\r'; // 'r' -> '\r'
            case 120:
                return String.fromCharCode(readHexChar(2, state)); // 'x'
            case 117:
                return codePointToString(readCodePoint(state)); // 'u'
            case 116:
                return '\t'; // 't' -> '\t'
            case 98:
                return '\b'; // 'b' -> '\b'
            case 118:
                return '\u000b'; // 'v' -> '\u000b'
            case 102:
                return '\f'; // 'f' -> '\f'
            case 48:
                return '\u0000'; // 0 -> '\0'
            case 13:
                if (state.input.charCodeAt(state.pos) === 10) {
                    ++state.pos;
                } // '\r\n'
            case 10:
                // ' \n'
                return '';
            default:
                return String.fromCharCode(ch);
        }
    }
}

function readCodePoint(state) {
    var ch = state.input.charCodeAt(state.pos);
    var code = undefined;

    if (ch === 123) {
        state.pos++;
        code = readHexChar(state.input.indexOf('}', state.pos) - state.pos, state);
        state.pos++;
        if (code > 1114111) {
            throw new Error('Unexpected "' + ch + '"');
        }
    } else {
        code = readHexChar(4, state);
    }
    return code;
}

function readHexChar(len, state) {
    var n = readInt(16, len, state);
    if (n === null) {
        throw new Error('Bad character escape sequence');
    }
    return n;
}

function readInt(radix, len, state) {
    var start = state.pos;
    var total = 0;
    for (var i = 0, e = len == null ? Infinity : len; i < e; ++i) {
        var code = state.input.charCodeAt(state.pos);
        var val = undefined;
        if (code >= 97) {
            // a
            val = code - 97 + 10;
        } else if (code >= 65) {
            // A
            val = code - 65 + 10;
        } else if (code >= 48 && code <= 57) {
            // 0-9
            val = code - 48;
        } else {
            val = Infinity;
        }
        if (val >= radix) {
            break;
        }
        state.pos++;
        total = total * radix + val;
    }

    if (state.pos === start || len != null && state.pos - start !== len) {
        return null;
    }

    return total;
}

function isNewLine(code) {
    return code === 10 || code === 13 || code === 8232 || code == 8233;
}

function codePointToString(code) {
    // UTF-16 Decoding
    if (code <= 65535) {
        return String.fromCharCode(code);
    }
    return String.fromCharCode((code - 65536 >> 10) + 55296, (code - 65536 & 1023) + 56320);
}

function readNumber(state) {
    var startsWithDot = state.input.charAt(0) === '.';
    var start = state.pos;
    var isFloat = false;
    var octal = state.input.charCodeAt(state.pos) === 48;
    if (!startsWithDot && readInt(10, null, state) === null) {
        throw new Error('Invalid number');
    }

    if (state.input.charCodeAt(state.pos) === 46) {
        state.pos++;
        readInt(10, null, state);
        isFloat = true;
    }

    var next = state.input.charCodeAt(state.pos);
    if (next === 69 || next === 101) {
        // 'eE'
        next = state.input.charCodeAt(++state.pos);
        if (next === 43 || next === 45) {
            state.pos++;
        } // '+-'
        if (readInt(10, null, state) === null) {
            throw new Error('Invalid number');
        }
        isFloat = true;
    }

    if (isIdentifierStart(fullCharCodeAtPos(state))) {
        throw new Error('Identifier directly after number');
    }

    var str = state.input.slice(start, state.pos);
    var val = undefined;
    if (isFloat) {
        val = parseFloat(str);
    } else if (!octal || str.length === 1) {
        val = parseInt(str, 10);
    } else if (/[89]/.test(str)) {
        throw new Error('Invalid number');
    } else {
        val = parseInt(str, 8);
    }

    return val;
}

var lineBreak = /\r\n?|\n|\u2028|\u2029/;

function readRegexp(state) {
    state.pos++;
    var escaped = undefined;
    var inClass = undefined;
    var start = state.pos;
    for (;;) {
        if (state.pos >= state.input.length) {
            throw new Error('Unterminated regular expression');
        }
        var ch = state.input.charAt(state.pos);
        if (lineBreak.test(ch)) {
            throw new Error('Unterminated regular expression');
        }
        if (!escaped) {
            if (ch === '[') {
                inClass = true;
            } else if (ch === ']' && inClass) {
                inClass = false;
            } else if (ch === '/' && !inClass) {
                break;
            }
            escaped = ch === '\\';
        } else {
            escaped = false;
        }
        state.pos++;
    }
    var content = state.input.slice(start, state.pos);
    state.pos++;
    // Need to use `readWord1` because '\uXXXX' sequences are allowed
    // here (don't ask).
    var mods = readWord1(state);
    var tmp = content;
    if (mods) {
        var validFlags = /^[gmsiyu]*$/;
        if (!validFlags.test(mods)) {
            throw new Error('Invalid regular expression flag');
        }
        if (mods.indexOf('u') >= 0) {
            // Replace each astral symbol and every Unicode escape sequence that
            // possibly represents an astral symbol or a paired surrogate with a
            // single ASCII symbol to avoid throwing on regular expressions that
            // are only valid in combination with the `/u` flag.
            // Note: replacing with the ASCII symbol `x` might cause false
            // negatives in unlikely scenarios. For example, `[\u{61}-b]` is a
            // perfectly valid pattern that is equivalent to `[a-b]`, but it would
            // be replaced by `[x-b]` which throws an error.
            tmp = tmp.replace(/\\u([a-fA-F0-9]{4})|\\u\{([0-9a-fA-F]+)\}|[\uD800-\uDBFF][\uDC00-\uDFFF]/g, 'x');
        }
    }
    // Detect invalid regular expressions.
    var value = null;

    try {
        new RegExp(tmp);
    } catch (e) {
        if (e instanceof SyntaxError) {
            throw new Error('Error parsing regular expression: ' + e.message);
        }
        throw e;
    }

    // Get a regular expression object for this pattern-flag pair, or `null` in
    // case the current environment doesn't support the flags it uses.
    try {
        value = new RegExp(content, mods);
    } catch (err) {}

    return value;
}

function readWord1(state) {
    var word = '';
    var first = true;
    var chunkStart = state.pos;
    var astral = true;
    while (state.pos < state.input.length) {
        var ch = fullCharCodeAtPos(state);
        if (isIdentifierChar(ch, astral)) {
            state.pos += ch <= 65535 ? 1 : 2;
        } else if (ch === 92) {
            // "\"
            word += state.input.slice(chunkStart, state.pos);
            if (state.input.charCodeAt(++state.pos) != 117) {
                // "u"
                throw new Error('Expecting Unicode escape sequence \\uXXXX');
            }
            state.pos++;
            var esc = readCodePoint(state);
            if (!(first ? isIdentifierStart : isIdentifierChar)(esc, astral)) {
                throw new Error('Invalid Unicode escape');
            }
            word += codePointToString(esc);
            chunkStart = state.pos;
        } else {
            break;
        }
        first = false;
    }
    return word + state.input.slice(chunkStart, state.pos);
}

function isIdentifierStart(code, astral) {
    if (code < 65) {
        return code === 36;
    }
    if (code < 91) {
        return true;
    }
    if (code < 97) {
        return code === 95;
    }
    if (code < 123) {
        return true;
    }
    if (code <= 65535) {
        return code >= 170 && nonASCIIidentifierStart.test(String.fromCharCode(code));
    }
    if (astral === false) {
        return false;
    }
    return isInAstralSet(code, astralIdentifierStartCodes);
}

// Test whether a given character is part of an identifier.

function isIdentifierChar(code, astral) {
    if (code < 48) {
        return code === 36;
    }
    if (code < 58) {
        return true;
    }
    if (code < 65) {
        return false;
    }
    if (code < 91) {
        return true;
    }
    if (code < 97) {
        return code === 95;
    }
    if (code < 123) {
        return true;
    }
    if (code <= 65535) {
        return code >= 170 && nonASCIIidentifier.test(String.fromCharCode(code));
    }
    if (astral === false) {
        return false;
    }
    return isInAstralSet(code, astralIdentifierStartCodes) || isInAstralSet(code, astralIdentifierCodes);
}

/* jscs: disable */

// ## Character categories

// Big ugly regular expressions that match characters in the
// whitespace, identifier, and identifier-start categories. These
// are only applied when a character is found to actually have a
// code point above 128.
// Generated by `tools/generate-identifier-regex.js`.

var nonASCIIidentifierStartChars = 'ªµºÀ-ÖØ-öø-ˁˆ-ˑˠ-ˤˬˮͰ-ʹͶͷͺ-ͽͿΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁҊ-ԯԱ-Ֆՙա-ևא-תװ-ײؠ-يٮٯٱ-ۓەۥۦۮۯۺ-ۼۿܐܒ-ܯݍ-ޥޱߊ-ߪߴߵߺࠀ-ࠕࠚࠤࠨࡀ-ࡘࢠ-ࢲऄ-हऽॐक़-ॡॱ-ঀঅ-ঌএঐও-নপ-রলশ-হঽৎড়ঢ়য়-ৡৰৱਅ-ਊਏਐਓ-ਨਪ-ਰਲਲ਼ਵਸ਼ਸਹਖ਼-ੜਫ਼ੲ-ੴઅ-ઍએ-ઑઓ-નપ-રલળવ-હઽૐૠૡଅ-ଌଏଐଓ-ନପ-ରଲଳଵ-ହଽଡ଼ଢ଼ୟ-ୡୱஃஅ-ஊஎ-ஐஒ-கஙசஜஞடணதந-பம-ஹௐఅ-ఌఎ-ఐఒ-నప-హఽౘౙౠౡಅ-ಌಎ-ಐಒ-ನಪ-ಳವ-ಹಽೞೠೡೱೲഅ-ഌഎ-ഐഒ-ഺഽൎൠൡൺ-ൿඅ-ඖක-නඳ-රලව-ෆก-ะาำเ-ๆກຂຄງຈຊຍດ-ທນ-ຟມ-ຣລວສຫອ-ະາຳຽເ-ໄໆໜ-ໟༀཀ-ཇཉ-ཬྈ-ྌက-ဪဿၐ-ၕၚ-ၝၡၥၦၮ-ၰၵ-ႁႎႠ-ჅჇჍა-ჺჼ-ቈቊ-ቍቐ-ቖቘቚ-ቝበ-ኈኊ-ኍነ-ኰኲ-ኵኸ-ኾዀዂ-ዅወ-ዖዘ-ጐጒ-ጕጘ-ፚᎀ-ᎏᎠ-Ᏼᐁ-ᙬᙯ-ᙿᚁ-ᚚᚠ-ᛪᛮ-ᛸᜀ-ᜌᜎ-ᜑᜠ-ᜱᝀ-ᝑᝠ-ᝬᝮ-ᝰក-ឳៗៜᠠ-ᡷᢀ-ᢨᢪᢰ-ᣵᤀ-ᤞᥐ-ᥭᥰ-ᥴᦀ-ᦫᧁ-ᧇᨀ-ᨖᨠ-ᩔᪧᬅ-ᬳᭅ-ᭋᮃ-ᮠᮮᮯᮺ-ᯥᰀ-ᰣᱍ-ᱏᱚ-ᱽᳩ-ᳬᳮ-ᳱᳵᳶᴀ-ᶿḀ-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼⁱⁿₐ-ₜℂℇℊ-ℓℕ℘-ℝℤΩℨK-ℹℼ-ℿⅅ-ⅉⅎⅠ-ↈⰀ-Ⱞⰰ-ⱞⱠ-ⳤⳫ-ⳮⳲⳳⴀ-ⴥⴧⴭⴰ-ⵧⵯⶀ-ⶖⶠ-ⶦⶨ-ⶮⶰ-ⶶⶸ-ⶾⷀ-ⷆⷈ-ⷎⷐ-ⷖⷘ-ⷞ々-〇〡-〩〱-〵〸-〼ぁ-ゖ゛-ゟァ-ヺー-ヿㄅ-ㄭㄱ-ㆎㆠ-ㆺㇰ-ㇿ㐀-䶵一-鿌ꀀ-ꒌꓐ-ꓽꔀ-ꘌꘐ-ꘟꘪꘫꙀ-ꙮꙿ-ꚝꚠ-ꛯꜗ-ꜟꜢ-ꞈꞋ-ꞎꞐ-ꞭꞰꞱꟷ-ꠁꠃ-ꠅꠇ-ꠊꠌ-ꠢꡀ-ꡳꢂ-ꢳꣲ-ꣷꣻꤊ-ꤥꤰ-ꥆꥠ-ꥼꦄ-ꦲꧏꧠ-ꧤꧦ-ꧯꧺ-ꧾꨀ-ꨨꩀ-ꩂꩄ-ꩋꩠ-ꩶꩺꩾ-ꪯꪱꪵꪶꪹ-ꪽꫀꫂꫛ-ꫝꫠ-ꫪꫲ-ꫴꬁ-ꬆꬉ-ꬎꬑ-ꬖꬠ-ꬦꬨ-ꬮꬰ-ꭚꭜ-ꭟꭤꭥꯀ-ꯢ가-힣ힰ-ퟆퟋ-ퟻ豈-舘並-龎ﬀ-ﬆﬓ-ﬗיִײַ-ﬨשׁ-זּטּ-לּמּנּסּףּפּצּ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼＡ-Ｚａ-ｚｦ-ﾾￂ-ￇￊ-ￏￒ-ￗￚ-ￜ';
var nonASCIIidentifierChars = '‌‍·̀-ͯ·҃-֑҇-ׇֽֿׁׂׅׄؐ-ًؚ-٩ٰۖ-ۜ۟-۪ۤۧۨ-ۭ۰-۹ܑܰ-݊ަ-ް߀-߉߫-߳ࠖ-࠙ࠛ-ࠣࠥ-ࠧࠩ-࡙࠭-࡛ࣤ-ःऺ-़ा-ॏ॑-ॗॢॣ०-९ঁ-ঃ়া-ৄেৈো-্ৗৢৣ০-৯ਁ-ਃ਼ਾ-ੂੇੈੋ-੍ੑ੦-ੱੵઁ-ઃ઼ા-ૅે-ૉો-્ૢૣ૦-૯ଁ-ଃ଼ା-ୄେୈୋ-୍ୖୗୢୣ୦-୯ஂா-ூெ-ைொ-்ௗ௦-௯ఀ-ఃా-ౄె-ైొ-్ౕౖౢౣ౦-౯ಁ-ಃ಼ಾ-ೄೆ-ೈೊ-್ೕೖೢೣ೦-೯ഁ-ഃാ-ൄെ-ൈൊ-്ൗൢൣ൦-൯ංඃ්ා-ුූෘ-ෟ෦-෯ෲෳัิ-ฺ็-๎๐-๙ັິ-ູົຼ່-ໍ໐-໙༘༙༠-༩༹༵༷༾༿ཱ-྄྆྇ྍ-ྗྙ-ྼ࿆ါ-ှ၀-၉ၖ-ၙၞ-ၠၢ-ၤၧ-ၭၱ-ၴႂ-ႍႏ-ႝ፝-፟፩-፱ᜒ-᜔ᜲ-᜴ᝒᝓᝲᝳ឴-៓៝០-៩᠋-᠍᠐-᠙ᢩᤠ-ᤫᤰ-᤻᥆-᥏ᦰ-ᧀᧈᧉ᧐-᧚ᨗ-ᨛᩕ-ᩞ᩠-᩿᩼-᪉᪐-᪙᪰-᪽ᬀ-ᬄ᬴-᭄᭐-᭙᭫-᭳ᮀ-ᮂᮡ-ᮭ᮰-᮹᯦-᯳ᰤ-᰷᱀-᱉᱐-᱙᳐-᳔᳒-᳨᳭ᳲ-᳴᳸᳹᷀-᷵᷼-᷿‿⁀⁔⃐-⃥⃜⃡-⃰⳯-⵿⳱ⷠ-〪ⷿ-゙゚〯꘠-꘩꙯ꙴ-꙽ꚟ꛰꛱ꠂ꠆ꠋꠣ-ꠧꢀꢁꢴ-꣄꣐-꣙꣠-꣱꤀-꤉ꤦ-꤭ꥇ-꥓ꦀ-ꦃ꦳-꧀꧐-꧙ꧥ꧰-꧹ꨩ-ꨶꩃꩌꩍ꩐-꩙ꩻ-ꩽꪰꪲ-ꪴꪷꪸꪾ꪿꫁ꫫ-ꫯꫵ꫶ꯣ-ꯪ꯬꯭꯰-꯹ﬞ︀-️︠-︭︳︴﹍-﹏０-９＿';

var nonASCIIidentifierStart = new RegExp('[' + nonASCIIidentifierStartChars + ']');
var nonASCIIidentifier = new RegExp('[' + nonASCIIidentifierStartChars + '' + nonASCIIidentifierChars + ']');

nonASCIIidentifierStartChars = nonASCIIidentifierChars = null;

// These are a run-length and offset encoded representation of the
// >0xffff code points that are a valid part of identifiers. The
// offset starts at 0x10000, and each pair of numbers represents an
// offset to the next range, and then a size of the range. They were
// generated by tools/generate-identifier-regex.js
var astralIdentifierStartCodes = [0, 11, 2, 25, 2, 18, 2, 1, 2, 14, 3, 13, 35, 122, 70, 52, 268, 28, 4, 48, 48, 31, 17, 26, 6, 37, 11, 29, 3, 35, 5, 7, 2, 4, 43, 157, 99, 39, 9, 51, 157, 310, 10, 21, 11, 7, 153, 5, 3, 0, 2, 43, 2, 1, 4, 0, 3, 22, 11, 22, 10, 30, 98, 21, 11, 25, 71, 55, 7, 1, 65, 0, 16, 3, 2, 2, 2, 26, 45, 28, 4, 28, 36, 7, 2, 27, 28, 53, 11, 21, 11, 18, 14, 17, 111, 72, 955, 52, 76, 44, 33, 24, 27, 35, 42, 34, 4, 0, 13, 47, 15, 3, 22, 0, 38, 17, 2, 24, 133, 46, 39, 7, 3, 1, 3, 21, 2, 6, 2, 1, 2, 4, 4, 0, 32, 4, 287, 47, 21, 1, 2, 0, 185, 46, 82, 47, 21, 0, 60, 42, 502, 63, 32, 0, 449, 56, 1288, 920, 104, 110, 2962, 1070, 13266, 568, 8, 30, 114, 29, 19, 47, 17, 3, 32, 20, 6, 18, 881, 68, 12, 0, 67, 12, 16481, 1, 3071, 106, 6, 12, 4, 8, 8, 9, 5991, 84, 2, 70, 2, 1, 3, 0, 3, 1, 3, 3, 2, 11, 2, 0, 2, 6, 2, 64, 2, 3, 3, 7, 2, 6, 2, 27, 2, 3, 2, 4, 2, 0, 4, 6, 2, 339, 3, 24, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 7, 4149, 196, 1340, 3, 2, 26, 2, 1, 2, 0, 3, 0, 2, 9, 2, 3, 2, 0, 2, 0, 7, 0, 5, 0, 2, 0, 2, 0, 2, 2, 2, 1, 2, 0, 3, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 1, 2, 0, 3, 3, 2, 6, 2, 3, 2, 3, 2, 0, 2, 9, 2, 16, 6, 2, 2, 4, 2, 16, 4421, 42710, 42, 4148, 12, 221, 16355, 541];
var astralIdentifierCodes = [509, 0, 227, 0, 150, 4, 294, 9, 1368, 2, 2, 1, 6, 3, 41, 2, 5, 0, 166, 1, 1306, 2, 54, 14, 32, 9, 16, 3, 46, 10, 54, 9, 7, 2, 37, 13, 2, 9, 52, 0, 13, 2, 49, 13, 16, 9, 83, 11, 168, 11, 6, 9, 8, 2, 57, 0, 2, 6, 3, 1, 3, 2, 10, 0, 11, 1, 3, 6, 4, 4, 316, 19, 13, 9, 214, 6, 3, 8, 112, 16, 16, 9, 82, 12, 9, 9, 535, 9, 20855, 9, 135, 4, 60, 6, 26, 9, 1016, 45, 17, 3, 19723, 1, 5319, 4, 4, 5, 9, 7, 3, 6, 31, 3, 149, 2, 1418, 49, 4305, 6, 792618, 239];

/* jscs: enable */

// This has a complexity linear to the value of the code. The
// assumption is that looking up astral identifier characters is
// rare.

function isInAstralSet(code, set) {
    var pos = 65536;
    for (var i = 0; i < set.length; i += 2) {
        pos += set[i];
        if (pos > code) {
            return false;
        }
        pos += set[i + 1];
        if (pos >= code) {
            return true;
        }
    }
}

function fullCharCodeAtPos(state) {
    var code = state.input.charCodeAt(state.pos);
    if (code <= 55295 || code >= 57344) {
        return code;
    }
    var next = state.input.charCodeAt(state.pos + 1);
    return (code << 10) + next - 56613888;
}

function readRadixNumber(radix, state) {
    state.pos += 2; // 0x
    var val = readInt(radix, null, state);
    if (val == null) {
        throw new Error('Expected number in radix ' + radix);
    }
    if (isIdentifierStart(fullCharCodeAtPos(state))) {
        throw new Error('Identifier directly after number');
    }
    return val;
}

/* jshint ignore:end */